// MSAEUtils.h
//
// Original version by Jon Lansdell and Nigel Humphreys.
// 4.0 and 3.1 updates by Greg Sutton.
// Apple Computer Inc 1996, all rights reserved.

#include <Types.h>
#include <Quickdraw.h>
#include <Packages.h>
#include <GestaltEqu.h>
#include <Editions.h>
#include <Printing.h>
#include <AppleEvents.h>
#include <ToolUtils.h>

#ifndef __MSAEUTILS__
#define __MSAEUTILS__

#include "MSToken.h"

	// Utility Routines for getting data from AEDesc's
	
void 	GetRawDataFromDescriptor(const AEDesc *theDesc, Ptr destPtr,
											Size destMaxSize, Size *actSize);
																		 
OSErr	GetPStringFromDescriptor(const AEDesc *aDesc, StringPtr resultStr);
OSErr	PutPStringToDescriptor(AEDesc* aDesc, StringPtr pStr);
OSErr	GetIntegerFromDescriptor(const AEDesc *sourceDesc, short *result);
OSErr	GetBooleanFromDescriptor(const AEDesc *sourceDesc, Boolean *result);
OSErr	GetLongIntFromDescriptor(const AEDesc *sourceDesc, long   *result);
OSErr	GetRectFromDescriptor(const AEDesc *sourceDesc, Rect *result);
OSErr	GetPointFromDescriptor(const AEDesc *sourceDesc, Point  *result);
OSErr	GetEnumeratedFromDescriptor(const AEDesc *sourceDesc, DescType  *result);

	// Parameter routines

OSErr		GotRequiredParams(const AppleEvent *theAppleEvent);
OSErr		AddResultToReply(AEDesc* result, AEDesc* reply, OSErr error);

	// Routine so events can be sent to self

OSErr		MakeSelfAddress(AEAddressDesc *selfAddress);


#endif